(function (exports) {
'use strict';

// A 'CNAME' record is a 32-bit value representing the IP address

exports.DNS_PACKER_TYPE_CNAME = function (ab, dv, total, record) {
  if (!record.data) {
    throw new Error("no data for CNAME record");
  }

  var cnameLen = 0;
  var rdLenIndex = total;
  total += 2;

  // RDATA
  // i.e. 127.0.0.1 => 0x7F, 0x00, 0x00, 0x01
  record.data.split('.').forEach(function (label) {
    cnameLen += 1 + label.length;
    
    dv.setUint8(total, label.length, false);
    total += 1;

    label.split('').forEach(function (ch) {
      dv.setUint8(total, ch.charCodeAt(0), false);
      total += 1;
    });
  });

  // RDLENGTH
  dv.setUint16(rdLenIndex, record.data.length + 1, false);
  
  return total;
};

}('undefined' !== typeof window ? window : exports));
